// aqd2asc.h : This file contains the header
//

// $Date: 2019-02-27 11:15:25 +0100 (Wed, 27 Feb 2019) $
// $Revision: 68740 $
// $Author: jhuizinga $
// $HeadURL: https://90.145.156.222/DMS-Houtribdijk/code/bin2asc/sourceADV/adv2asc.h $

// Clock data (6 bytes) NOTE! BCD format
typedef struct {
  unsigned char cMinute; // minute
  unsigned char cSecond; // second
  unsigned char cDay; // day
  unsigned char cHour; // hour
  unsigned char cYear; // year
  unsigned char cMonth; // month
} PdClock;

// Aquadopp velocity data 3 beams
typedef struct {
  unsigned char  cSync;           // sync = 0xa5
  unsigned char  cId;             // identification (0x21 = 3 beams, 0x22 = 2 beams, 0x21 = 1 beam)
  unsigned short hSize;           // size of structure (words)
  PdClock        clock;           // date and time
  unsigned short hMilliseconds;   // milliseconds
  short          hError;          // error code
  unsigned short hBattery;        // battery voltage (0.1 V)
  unsigned short hSoundSpeed;     // speed of sound (0.1 m/s)
  short          hHeading;        // compass heading (0.1 deg)
  short          hPitch;          // compass pitch (0.1 deg)
  short          hRoll;           // compass roll (0.1 deg)
  unsigned char  cPressureMSB;    // pressure MSB
  char           cStatus;         // status
  unsigned short hPressureLSW;    // pressure LSW
  short          hTemperature;    // temperature (0.01 deg C)
  unsigned short hAnaIn1;         // analog input 1
  unsigned short hAnaIn2;         // analog input 2
  unsigned char  nBeams;          // Number of beams
  unsigned char  nCells;          // Number of cells
  short          hVelLag2[3];     // Velocity Lag 2 - array of 3 - 1 per beam
  unsigned char  hAmpLag2[3];     // Amplitude Lag 2 - array of 3 - 1 per beam
  unsigned char  hCorrLag2[3];    // Correlation Lag 2 - array of 3 - 1 per beam  (0-100)
  short          hSpare[3];       // spare's
  short          hVel[3][15];     // velocity
  unsigned char  cAmp[3][15];     // amplitud
  unsigned char  cCorr[3][15];    // correlation  (0-100
  unsigned short hChecksum;       // checksum
} PdHrProf;

char *decimal_to_binary(char);
unsigned short Checksum(short *, int);
